import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.*;

public class DrawingPanel extends JPanel{
	static final int RADIUS = 10;
	static final int THRESHOLD = 10;
	ArrayList<Point2D> points = new ArrayList<Point2D>();
	
	public DrawingPanel(){
		MyMouseAdapter mouseAdapter = new MyMouseAdapter();
		addMouseListener (mouseAdapter);
		addMouseMotionListener(mouseAdapter);
	}
	
    protected void paintComponent(Graphics graphics){
    	super.paintComponent(graphics);
    	Graphics2D g = (Graphics2D) graphics;
    	
    	g.setPaint (Color.BLACK);
    	//for(Point2D point:points){
		for(int i=0; i<points.size(); i++){
			Point2D point = points.get(i);
   		  	int x = (int)point.getX()-(RADIUS/2);
    		  int y = (int)point.getY()-(RADIUS/2);
    		  g.fillOval(x,y,RADIUS,RADIUS);
    	}
    }
    
    
	private class MyMouseAdapter extends MouseAdapter{
	
		public void mousePressed (MouseEvent e){
			if(e.getButton()==MouseEvent.BUTTON1){
				points.add(e.getPoint());
			} else if (e.getButton()==MouseEvent.BUTTON3){
				// Search through list and delete nearest neighbor within some threshold
				int nearestIndex = -1;
				double nearestDistance = Double.MAX_VALUE;
				for(int i=0; i<points.size(); i++){
					Point2D current = points.get(i);
					if(current.distance(e.getPoint())<nearestDistance){
						nearestIndex = i;
						nearestDistance=current.distance(e.getPoint());
					}
				}
				if(nearestDistance<=THRESHOLD){
					//Delete point
					points.remove(nearestIndex);
				}
			}
			repaint();
		}


	};
	
}